function analog_sample()
% erst test, dann Aufnahme von Lmpchen- und Batteriekennlinien Mrz 2008
for (i = 1:20);
start = cputime;
time = (i-1)*0.050;
volts = eanalogin(-1,0,1,0);         % Sample analog signal using AI1
data(i,:) = [time volts];           % Data array for plotting
elapsed = start-cputime;             % Calculate the time elapsed during funciton call
pause(0.050-elapsed);                % Pause for remainder of 50 ms sample period 
end

% Plot data
plot(data(:,1),data(:,2));
title('Analog Input Channel 1');
xlabel('Time (s)');
ylabel('AI1 Input (V)');
grid on;

%%
U=0:0.01:2.7;
U=[U 2.7:-0.01:0];
n=length(U)
for i=1:n,
EAnalogOut(-1,0,U(i),0);
%pause(80);
disp(['U = ' num2str(U(i)) ' V']);
[I(i) b c d]=eanalogin(-1,0,8,7);
[Umeas(i), b c d]=eanalogin(-1,0,1,0);
end
plot(U,-I-5.7e-3)
grid
axis([0 3 0 0.05])
xlabel('U/V')
ylabel('I/A')
title('Labjack, uncalibrated, 4 lamps, 80 s pause')
plot(U,U./(-I-5.7e-3))
plot(U,U./(-I-5.7e-3),'*')
xlabel('U/V')
ylabel('R/Ohm')
title('Labjack, uncalibrated, 4 lamps, 80 s pause')
grid
cd('D:\Eigene Dateien\MYMATLAB\Data')
%save 4lamps80 U I

%% Jetzt mit externer Spannungsquelle:
U=[];
I=[];
f=10/6; % Spannungsteilerfaktor
while 1,
    [value b c d]=eanalogin(-1,0,8,7); % Spannungsabfall  an 1 Ohm-Widerstand
    I=[I value];
    [value, b c d]=eanalogin(-1,0,9,0); % Spannungsabfall an Spannungsteiler
    U=[U f*value];
    disp(['U = ' num2str(f*value) ' V']);
    if f*value>14, break; end
end
U=U_down;
I=I_down;
U=0.99745*U-0.00225*f;  % calibration, see below
I=0.00491+0.97838*I-0.3225*I.^2; % calibration, see below
I=I-U/10000; % correction for voltage divider current
plot(U-0.0433,I); % U still has a small offset!
cd('D:\Eigene Dateien\MYMATLAB\Data')
%save 4lamps U_up I_up U_down I_down
R=(U-0.0433)./I;
dR=sqrt((R./(U-0.0433)*0.02).^2+(R./I*0.001).^2);
x=U-0.0433;
y=R;
w=1./dR.^2;
cftool(x,y,w)
% fit: 30.13*U^0.4036-4.10 Ohm (ok fr U>0.3 V)
%% calibration
% Labjack raw measured versus Multimeter
% I(labjack, mA) as x, I(mV Multimeter) as y
plot(0.001*[137.2 185.5 92.8 60.06 41.99 26.86 16.11 -.97 -4.86],0.001*[133.1 175.3 92.9 62.5 45.3 31.2 20.5 4.1 0],'+')
% U(labjack, V) as x, U(Multimeter) as y
plot([5.5957 8.9941 3.0078 1.5137 0.8398 .3906 .17578 .04883 .02930],[5.58 8.97 2.995 1.504 .836 .385 .1757 .0495 0.0277],'*')


%% anderer Aufbau, erst Spannungsteiler, dann Strom-R (Schaltung 2)
[value1 b c d]=EAnalogIn(-1,0,9,0); disp(value1); % Spannung an Spannungsteiler
[value2 b c d]=EAnalogIn(-1,0,8,7); disp(value2); % diff. Spannungsabfall an R, =I
UB=0:0.01:5; % Base voltage transistor
% Kennlinie
for i=1:length(UB), % UB = 0.5-2.5 V steuert praktisch voll aus. 
    EAnalogOut(-1,0,UB(i),0) % AO0 to UB Volt
    [value1 b c d]=EAnalogIn(-1,0,9,0); % Spannung an Spannungsteiler????
    [value2 b c d]=EAnalogIn(-1,0,8,7);  % diff. Spannungsabfall an R, =I
    U1(i)=value1; U2(i)=value2;
end 

% bei U0=0 wird U richtig zu 0 gemessen, aber I zu -0.0048828125 V =-20/4096
% V
U=[];
I=[];
f=10/5; % Spannungsteilerfaktor
while 1,
    [value1 b c d]=eanalogin(-1,0,8,7); % Spannungsabfall  an 1 Ohm-Widerstand
    I=[I value1];
    [value2, b c d]=eanalogin(-1,0,2,0); % Spannungsabfall an Spannungsteiler
    U=[U f*value2];
    disp(['U = ' num2str(f*value2) ' V']);
    if value>15, break; end
end
 % save 4lamps_schaltung2  U I
 
 
 
%% Kalibration Labjack, AI2-GND, 1Ohm-R berbrckt sodass gleiche Spannung
% am Multimeter wie am Labjack:
% data: linke Spalte U(Multimeter), rechte Spalte U(LJ) per [value1 b c
% d]=eanalogin(-1,0,2,0); disp(value1);

data=[0 0
    0.049 0.0488
    0.1040 0.10742
    0.174 0.1758
    0.429 0.4346
    0.511 0.5178
    0.698 0.7031
    0.697 0.6982
    0.989 0.9935
    1.3645 1.3721
    1.980 1.9873
    3.00 3.008
    4.07 4.082
    5.02 5.029
    6.02 6.030
    7.06 7.070
    8.05 8.057
    9.08 9.092
    9.91 9.927
    9.97 9.985];
x=data(:,1); y=data(:,2);
sig=sqrt((0.02*x).^2+(0.002*y).^2+(3*(20/2^12))^2); % 2% for Multimeter, 0.2% absolute accuracy LJ, 3x 1 bit LJ resolution/repeat/linearity
cftool(x,y,1./sig.^2)
% Linear model Poly1:
%        f(x) = p1*x + p2
% Coefficients (with 95% confidence bounds):
%        p1 =       1.00198832353289  (1.001, 1.003)
%        p2 =    0.00219095092505719  (0.0009506, 0.003431)
% 
% Goodness of fit:
%   SSE: 0.1621
%   R-square: 1
%   Adjusted R-square: 1
%   RMSE: 0.0949

%% Jetzt den diff. Kanal AI0-AI1:
% AI0-AI1 und Multimeter beide  an
% Netzteil angeschlossen  [value2 b c d]=eanalogin(-1,0,8,7);  disp(value2);
% data: linke Spalte U(Multimeter), rechte Spalte U(LJ) per [value2 b c
% d]=eanalogin(-1,0,8,7);  disp(value2); 
% open circuit (Netzteil): ULJ=1.284 V!
data=[0 -0.0053
    0.0058 0.00049
    0.0251 0.0205078125
    0.0539 0.04931
    0.0968 0.0918
    0.1544 0.1494
    0.201  0.1958 
    0.271   0.2661
    0.308   0.30322
    0.406 0.401367
    0.524 0.51855
    0.625 0.6206
    0.712 0.7065
    0.802 0.7964
    0.895 0.88965
    0.963 0.9575];
%    >=0.998:  0.9794921875
x=data(:,1); y=data(:,2);
sig=sqrt((0.02*x).^2+(0.01*y).^2+(22.5*(20/2^12))^2); % 2% for Multimeter, 1% absolute accuracy LJ, 2.5x 1 bit LJ resolution/repeat/linearity, 20 bit offset
cftool(x,y,1./sig.^2)

% Linear model Poly1:
%        f(x) = p1*x + p2
% Coefficients (with 95% confidence bounds):
%        p1 =      0.999500455595999  (0.9989, 1)
%        p2 =    -0.00488000018184039  (-0.005175, -0.004585)
% 
% Goodness of fit:
%   SSE: 0.0001476
%   R-square: 1
%   Adjusted R-square: 1
%   RMSE: 0.003247

%% Analyse der gemessenen Kennlinie
cd('D:\Eigene Dateien\MYMATLAB\DATA');
load 4lamps_schaltung2.mat % I, U Rohwerte in Volt
I=1.0005*I+0.004882; % Korrektur der Spannung,die am Messwiderstand abfllt
U=0.998*U-0.002186; % Korrektur der Spannung am Spannungsteiler
U=U-I*1; % Korrektur der Klemmenspannung am Verbraucher durch den Spannungsabfall am Messwiderstand
plot(U,I,'b.','markersize',1)
dU=2*sqrt((0.001*U).^2+(0.002*U).^2+(1*(20/2^12))^2); %  0.2% absolute accuracy LJ, 3x 1 bit LJ resolution/repeat/linearity , 0.1% Spannungsteiler, 2* wegen Faktor 2  
dI=sqrt(2*(0.01*I).^2+(1*(20/2^12))^2); % 1% Messwiderstand, 1% absolute accuracy LJ, 2.5x 1 bit LJ resolution/repeat/linearity, 20 bit offset??

% 4 Lmpchen bei kleinen Spannungen, 2Multimeter-Messung
data=[1.94 52.7
    1.498 45.8
    1.005 37.2
    0.741 32.1
    0.604 29.35
    0.552 28.2
    0.504 27.1
    0.500 27.0
    0.398 24.5
    0.397 24.5
    0.351 23.2
    0.305 21.7
    0.249 19.6
    0.174 15.8
    0.152 14.4
    0.125 12.4
    0.100 10.35
    0.073 7.9
    0.050 5.55
    0.025 2.8
    0.0103 1.2
    0 0];
U1=data(:,1); I1=0.001*data(:,2);
dU1=0.01*U1; % 1% 
dI1=0.01*I1; % 1% 
hold on; grid
plot(U1,I1,'r+')

% systematische Fehler in I (up/down..):
u=[0 0.2 0.24 0.25 0.265 .4 1 5 8 9 12.7 15 18.5];
di=[0 .5 1 1.5 4.5 1.5 .5 .4 1 2.5 2 1.5 .7]/2/1000; % graphisch 
% u, di kann man linear interpolieren
% fitte U,I ganz grob mit I=0.03397*U^0.6; dies ableiten:
% dI/dU=0.02*U^(-0.4) for U>0.3V; below, use dI/dU=0.1 (R~const=10 Ohm)
x=[U'; U1];
y=[I'; I1];
sigx=[dU'; dU1];
sigy=[dI'; dI1];
sigy_syst=interp1(u,di,x);
idx=find(x>0.3);
dydx=0.1*myzeros(x);
dydx(idx)=0.02*x(idx).^(-0.4);
sigytot=sigy_syst+sqrt(sigy.^2+(dydx.*sigx).^2);
w=1./sigytot.^2;

plot(x,sigytot,'m.','markersize',1)

save 4lamps_schaltung2res I U I1 U1 x y sigytot w
% Widerstand:

R=x./y;
idx=find(isnan(R)|R<0|x<0); R(idx)=[];
xx=x;
xx(idx)=[];
dR=sqrt((sigx./y).^2+(sigy.*x./y).^2); dR(idx)=[];
wR=1./dR.^2; 

figure
plot(xx,R,'*','markersize',1)
hold on; grid;
plot(U1,U1./I1,'r+')
plot(xx,dR,'.m','markersize',1)

%% Make normalpoints R vs. U
xi=[0:0.05:0.3,0.4:0.1:1,1.2:0.2:3,3.5:0.5:8,9:1:20];
M=2; % Grad des fitpolynoms
yi=[]; dyi=[];
for m=1:length(xi)-1,
    idx=find(xx>=xi(m) & xx<xi(m+1)); disp(['m, no. : ' int2str(m) ', ' int2str(length(idx))])
    xxx=xx(idx)-xi(m); % normiere auf Anfang des Intervalls
    [a,da,chi2red,covar,q,dum] = lfit(xxx',R(idx)',dR(idx)',M,1,[]);
    yi(m)=a(1); dyi(m)=da(1);
end
xi(end)=[];
% Resultat: U/V, R/Ohm, dR/Ohm
data = [   0       8.3711      0.11172
         0.05       8.8524     0.045403
          0.1       9.6834     0.067316
         0.15       10.398     0.050464
          0.2       11.364     0.038526
         0.25       13.485     0.057293
          0.3       13.531     0.040012
          0.4         16.1     0.039988
          0.5       18.489     0.044624
          0.6       20.492      0.04414
          0.7       22.326     0.027873
          0.8       24.017     0.033453
          0.9       25.662     0.021115
            1       27.011     0.016972
          1.2        29.21     0.024766
          1.4        31.39     0.018815
          1.6       33.719     0.023206
          1.8       35.574     0.019996
            2       37.288     0.025607
          2.2       38.874     0.027886
          2.4       40.354      0.03059
          2.6       41.853     0.015112
          2.8       43.231     0.031557
            3       44.275     0.023584
          3.5       47.239     0.026634
            4       50.137     0.036153
          4.5       52.799     0.063368
            5       55.014     0.049821
          5.5       57.389      0.05624
            6       59.496     0.060079
          6.5       61.447     0.048794
            7       63.564     0.047001
          7.5       65.589     0.035407
            8       66.765     0.023473
            9       69.884     0.026779
           10       72.321     0.051341
           11       75.599     0.025802
           12       78.107     0.046712
           13       80.429     0.060125
           14       83.247       0.0337
           15        86.04     0.066057
           16       88.233     0.057258
           17       90.406     0.049937
           18       92.637     0.046387
           19       94.813      0.12902];

% N.B.: Fehler sind nicht realistisch, man muss die syst. Fehler
% draufaddieren!
%% Entladekurve Batterie

Ud=[];
Id=[];
t=[]; 
f=10/5; % Spannungsteilerfaktor
while 1,
    [value1 b c d]=eanalogin(-1,0,8,7); % Spannungsabfall  an 1 Ohm-Widerstand
    Id=[Id value1];
    [value2, b c d]=eanalogin(-1,0,2,0); % Spannungsabfall an Spannungsteiler
    Ud=[Ud f*value2];
    t=[t datenum(clock)]; % in fractional days since 1-Jan-0000
    disp(['U = ' num2str(f*value2) ' V']);
    pause(10)
    
end

Ud=Ud-Id;
t=(t-t(1))*24;

save discharge12V7Ah Id Ud t

%% Jetzt Hochstromentlandung an 4.7 Ohm Widerstand; G=5 (n=3) setzen (+/- 4 Volt
% diff.)

Ud=[];
Id=[];
t=[]; 
load handel
f=1; % Spannungsteilerfaktor
cutoff=6;
figure
while 1,
    for i=1:100,
        [value1(i) b c d]=EAnalogIn(-1,0,8,0); % Spannungsabfall  an 1 Ohm-Widerstand (Strommessung hinter U)
        [value2(i) b c d]=EAnalogIn(-1,0,9,0); % Spannungsabfall an Spannungsteiler
        temp(i)=datenum(clock);
    end
    Id=[Id mean(value1)];    Ud=[Ud f*mean(value2)];
    t=[t mean(temp)]; % in fractional days since 1-Jan-0000
    disp(['U = ' num2str(f*mean(value2)) ' +/- ' num2str(f*std(value2)) ' V, I = ' num2str(mean(value1)) ' +/- ' num2str(std(value1)) ' A']);
    pause(5)
    subplot(2,1,1)
    plot(t,Ud); grid on;
    subplot(2,1,2)
    plot(t,Id); grid on; 
    drawnow;
    if f*mean(value2)<cutoff, 
        sound(y); % Halleluhja...
        break; 
    end
end

% Ud is battery terminal voltage; at 4.7 Ohm-resistor, it is Ud-Id
td=(t-t(1))*24; % hours real start of discharge at 0.01721 h

%% plot
subplot(2,1,1)
plot(td,Ud)
grid
ylabel('Ud, V')
title(['Discharge at ' num2str(runde(mean(Id),3)) 'A, cutoff ' num2str(cutoff) ' V'])
hold
subplot(2,1,2)
plot(td,Id)
grid
hold
xlabel('td, hours')
ylabel('Id, A')

idx=locate(td,0.09974); idx2=locate(Ud,6);
Ah=trapz(td(idx:idx2),Id(idx:idx2)) % 2.652 Ah for 2 Ohm, 0.5485 if to 6 V
cd('D:\Eigene Dateien\MYMATLAB\DATA\battery')
fn=['discharge12V7Ah_' num2str(runde(mean(Id),3)) '.mat'];
Str=['save ' fn ' Ud Id td Ah'];
disp(Str)
eval(Str)

%% Kennlinie Schalter-Glhbirne:
I=[]; U=[]; i=1;
while 1,
        [I(i) b c d]=EAnalogIn(-1,0,8,7); % Spannungsabfall  an 1 Ohm-Widerstand (Strommessung hinter U)
        [U(i) b c d]=EAnalogIn(-1,0,9,0); % Spannungsabfall an Spannungsteiler
        i=i+1;
end
% Result: U/Volt, RL_Signal (Ohm)
data=[1.5 79.5
 2.0 88.7
 2.5 96.4
 3.0 103.2
 3.5 109.8
 4.0 115.5
 4.5 120.2
 5.0 125.2
 6.0 133.1 
 7.0 141.4
 8.0 148.1
 9.0 154.3
 10.0 160.4
 11.0 165.6
 12.0 170.5 
 13.0 175.3
 14.0 179.8
 15.0 184.2];
 